exports = module.exports = {}

exports.initData = {
  id: 0,
  num_cars: 1,
  map: {
    tile_width: 128,
    tile_height: 128,
    tiles: [
      [
        ".",
        ".",
        ".",
        ".",
        ".",
        ".",
        ".",
        "."
      ],
      [
        ".",
        "/",
        "-",
        "-",
        "-",
        "`",
        ".",
        "."
      ],
      [
        ".",
        "|",
        ".",
        ".",
        ".",
        "|",
        ".",
        "."
      ],
      [
        ".",
        "|",
        ".",
        ".",
        ".",
        "|",
        ".",
        "."
      ],
      [
        ".",
        "\\",
        "-",
        "-",
        "-",
        ",",
        ".",
        "."
      ],
      [
        ".",
        ".",
        ".",
        ".",
        ".",
        ".",
        ".",
        "."
      ]
    ],
    modifiers: [
      {
        type: "mud",
        x: 168,
        y: 218,
        width: 64,
        height: 64
      },
      {
        type: "booster",
        x: 418,
        y: 538,
        width: 32,
        height: 32
      },
      {
        type: "ice",
        x: 638,
        y: 188,
        width: 64,
        height: 64
      }
    ],
    path: [
      {
        tile_x: 3,
        tile_y: 1
      },
      {
        tile_x: 4,
        tile_y: 1
      },
      {
        tile_x: 5,
        tile_y: 1
      },
      {
        tile_x: 5,
        tile_y: 2
      },
      {
        tile_x: 5,
        tile_y: 3
      },
      {
        tile_x: 5,
        tile_y: 4
      },
      {
        tile_x: 4,
        tile_y: 4
      },
      {
        tile_x: 3,
        tile_y: 4
      },
      {
        tile_x: 2,
        tile_y: 4
      },
      {
        tile_x: 1,
        tile_y: 4
      },
      {
        tile_x: 1,
        tile_y: 3
      },
      {
        tile_x: 1,
        tile_y: 2
      },
      {
        tile_x: 1,
        tile_y: 1
      },
      {
        tile_x: 2,
        tile_y: 1
      }
    ]
  }
}

exports.carIsTopAndFacingRight = {
  cars: [
    {
      id: 0,
      direction: {
        x: 1,
        y: 0
      },
      velocity: {
        x: 135.245651,
        y: -4.1e-05
      },
      pos: {
        x: 649,
        y: 167
      },
      drift: 0,
      width: 22,
      height: 28,
      powerup: "none"
    }
  ],
  shells: [],
  boxes: [
    {
      x: 576,
      y: 153,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 174,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 195,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 216,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 537,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 558,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 579,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 600,
      width: 16,
      height: 16
    }
  ],
  items: []
}

exports.carIsTopRightAndFacingDown = {
  cars: [
    {
      id: 0,
      direction: {
        x: 0.390726,
        y: 0.920497
      },
      velocity: {
        x: 69.207436,
        y: 83.789398
      },
      pos: {
        x: 692,
        y: 265
      },
      drift: 0,
      width: 22,
      height: 28,
      powerup: "blueshell"
    }
  ],
  shells: [],
  boxes: [
    {
      x: 576,
      y: 153,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 174,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 216,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 537,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 558,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 579,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 600,
      width: 16,
      height: 16
    }
  ],
  items: []
}

exports.carIsBottomAndFacingLeft = {
  cars: [
    {
      id: 0,
      direction: {
        x: -0.906307,
        y: 0.422617
      },
      velocity: {
        x: -33.72765,
        y: 15.728352
      },
      pos: {
        x: 586,
        y: 652
      },
      drift: 0,
      width: 22,
      height: 28,
      powerup: "none"
    }
  ],
  shells: [],
  boxes: [
    {
      x: 576,
      y: 153,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 174,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 195,
      width: 16,
      height: 16
    },
    {
      x: 576,
      y: 216,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 537,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 558,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 579,
      width: 16,
      height: 16
    },
    {
      x: 448,
      y: 600,
      width: 16,
      height: 16
    }
  ],
  items: []
}